/*
 * An example plugin that shows subscribing to channels
 *
 * $Copyright (c) 2014, 2022 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 *
 */

import com.apama.epl.plugin.Correlator;
import com.apama.epl.plugin.EventHandler;

/**
	Demonstrates a plugin subscribing to channels to receive events
*/
public class SubscribePlugin
{
	public static class SubscribeHandler implements EventHandler
	{
		public void handleEvent(String event, String channel)
		{
			System.out.println("Got event "+event+" on channel "+channel);
		}
	}
	public static Object createHandler(String channel)
	{
		SubscribeHandler h = new SubscribeHandler();
		Correlator.subscribe(h, channel);
		return h;
	}
}
