#!/usr/bin/env python3

# Copyright (c) 2022 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
# Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG

# This python script is just for the sake of testing and does not provide real temperature readings.
import paho.mqtt.client as mqtt
import time
import random, json
from datetime import datetime
import argparse

if __name__ == "__main__":
	parser = argparse.ArgumentParser()
	parser.add_argument('--host', dest='broker', type=str, default='localhost', help='The hostname where the MQTT broker is running.')
	parser.add_argument('--port', dest='port', type=int, default=1883, help='The MQTT broker port to connect to.')
	args = parser.parse_args()

	mqttClient = mqtt.Client("Low-latency")

	def on_publish(client, userdata, result):  # create function for callback
			print("data published \n")
			

	def on_connect(client, userdate, flags, rc):
			print("Connected to mosquitto " + args.broker + " with result {0}".format(rc))

	mqttClient.on_connect = on_connect
	mqttClient.on_publish = on_publish
	mqttClient.connect(args.broker, args.port)

	while True:
		now = datetime.now()
		data = {}
		data['time'] = now

		temp = random.uniform(0,150)
		data['temperature'] = temp

		mqttClient.publish('sensors/temperature', json.dumps(data , default = str))
		time.sleep(0.5)
